/*
 *  Copyright 2007-2008, Plutext Pty Ltd.
 *   
 *  This file is part of docx4j.

    docx4j is licensed under the Apache License, Version 2.0 (the "License"); 
    you may not use this file except in compliance with the License. 

    You may obtain a copy of the License at 

        http://www.apache.org/licenses/LICENSE-2.0 

    Unless required by applicable law or agreed to in writing, software 
    distributed under the License is distributed on an "AS IS" BASIS, 
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
    See the License for the specific language governing permissions and 
    limitations under the License.

 */


package org.docx4j.dml.chart;

import javax.xml.bind.annotation.XmlEnum;
import javax.xml.bind.annotation.XmlEnumValue;
import javax.xml.bind.annotation.XmlType;


/**
 * <p>Java class for ST_BarDir.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * <p>
 * <pre>
 * &lt;simpleType name="ST_BarDir">
 *   &lt;restriction base="{http://www.w3.org/2001/XMLSchema}string">
 *     &lt;enumeration value="bar"/>
 *     &lt;enumeration value="col"/>
 *   &lt;/restriction>
 * &lt;/simpleType>
 * </pre>
 * 
 */
@XmlType(name = "ST_BarDir")
@XmlEnum
public enum STBarDir {


    /**
     * Bar
     * 
     */
    @XmlEnumValue("bar")
    BAR("bar", "bar"),

    /**
     * Column
     * 
     */
    @XmlEnumValue("col")
    COL("col", "column");
    private final String value;
    private final String realValue;
    
    STBarDir(String v, String rv) {
        value = v;
        realValue = rv;
    }

    public String value() {
        return value;
    }
    
    public String getRealValue() {
        return realValue;
    }

    public static STBarDir fromValue(String v) {
        for (STBarDir c: STBarDir.values()) {
            if (c.value.equals(v)) {
                return c;
            }
        }
        throw new IllegalArgumentException(v);
    }

    public static STBarDir fromRealValue(String v) {
        for (STBarDir c: STBarDir.values()) {
            if (c.realValue.equals(v)) {
                return c;
            }
        }
        throw new IllegalArgumentException(v);
    }

}
