
Name:          open-xchange-documents-backend
BuildArch:     noarch
#!BuildIgnore: post-build-checks
BuildRequires: ant
BuildRequires: ant-nodeps
BuildRequires: open-xchange-core
BuildRequires: open-xchange-grizzly
BuildRequires: open-xchange-oauth
BuildRequires: open-xchange-realtime-core
BuildRequires: open-xchange-documentconverter-api
BuildRequires: java-devel >= 1.6.0
Version:       7.4.2
%define        ox_release 11
Release:       %{ox_release}_<CI_CNT>.<B_CNT>
Group:         Applications/Productivity
License:       GPL-2.0
BuildRoot:     %{_tmppath}/%{name}-%{version}-build
URL:           http://www.open-xchange.com/
Source:        %{name}_%{version}.orig.tar.bz2
Summary:       The Open-Xchange backend office extension
Requires:      open-xchange-core >= 7.4.2
Requires:      open-xchange-grizzly >= 7.4.2
Requires:      open-xchange-oauth >= 7.4.2
Requires:      open-xchange-realtime-core >= 7.4.2
Requires:      open-xchange-realtime-json >= 7.4.2
Requires:      open-xchange-documentconverter-api >= 7.4.2
Requires:      open-xchange-file-distribution >= 7.4.2
Obsoletes:     open-xchange-documents-core < 7.4.2
Obsoletes:     open-xchange-calcengineserver < 7.4.2
Provides:      open-xchange-documents-backend = %{version}
Provides:      open-xchange-documents-core = %{version}
Provides:      open-xchange-calcengineserver = %{version}


%description
This package contains the backend components for the office productivity

Authors:
--------
    Open-Xchange

%prep
%setup -q

%build

%install
export NO_BRP_CHECK_BYTECODE_VERSION=true
ant -lib build/lib -Dbasedir=build -DdestDir=%{buildroot} -DpackageName=%{name} -f build/build.xml clean build
rm -f %{configfiles}
find %{buildroot}/opt/open-xchange/etc \
        -type f \
        -printf "%%%config(noreplace) %p\n" > %{configfiles}
perl -pi -e 's;%{buildroot};;' %{configfiles}
perl -pi -e 's;(^.*?)\s+(.*/(mail|configdb|server|filestorage)\.properties)$;$1 %%%attr(640,root,open-xchange) $2;' %{configfiles}



%post
. /opt/open-xchange/lib/oxfunctions.sh
CONFFILES="settings/office.properties conf/jms.properties conf/calcengine.properties conf/hunspell.properties"
for FILE in $CONFFILES; do
    ox_move_config_file /opt/open-xchange/etc/groupware /opt/open-xchange/etc $FILE
done


%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-,root,root)
%dir /opt/open-xchange/bundles/
/opt/open-xchange/bundles/*
%dir /opt/open-xchange/etc/
/opt/open-xchange/etc/*
%dir /opt/open-xchange/lib/
/opt/open-xchange/lib/*
%dir /opt/open-xchange/osgi/bundle.d/
/opt/open-xchange/osgi/bundle.d/*
%dir /opt/open-xchange/sbin/
/opt/open-xchange/sbin/*

%changelog
* Tue Aug 19 2014 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Build for patch 2014-08-25
* Tue Jul 08 2014 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Build for patch 2014-07-17
* Thu Mar 27 2014 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Third candidate for 7.4.2 Spreadsheet Final release
* Wed Mar 26 2014 Martin Hollmichel <martin.hollmichel@open-xchange.com>
First candidate for 7.4.2 Spreadsheet Final release
* Wed Feb 26 2014 Martin Hollmichel <martin.hollmichel@open-xchange.com>
First candidate for 7.4.2 spreadsheet release
* Fri Feb 07 2014 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Sixth candidate for 7.4.2 release
* Thu Feb 06 2014 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Fifth candidate for 7.4.2 release
* Tue Feb 04 2014 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Fourth candidate for 7.4.2 release
* Thu Jan 23 2014 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Third candidate for 7.4.2 release
* Fri Jan 10 2014 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Second candidate for 7.4.2 release
* Mon Dec 23 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
First candidate for 7.4.2 release
* Thu Dec 19 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
prepare for 7.4.2
* Tue Dec 10 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
preparation for 7.0.1 - sprint #19
* Wed Nov 20 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Fifth candidate for 7.4.1 release
* Fri Nov 15 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Fourth candidate for 7.4.1 release
* Thu Nov 07 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Third candidate for 7.4.1 release
* Wed Oct 23 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Second candidate for 7.4.1 release
* Thu Oct 10 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
First sprint increment for 7.4.1 release
* Tue Sep 24 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Eleventh candidate for 7.4.0 release
* Fri Sep 20 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
prepare for 7.4.1 release
* Fri Sep 20 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Tenth candidate for 7.4.0 release
* Thu Sep 12 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Ninth candidate for 7.4.0 release
* Sun Sep 01 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Eighth candidate for 7.4.0 release
* Tue Aug 27 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Seventh candidate for 7.4.0 release
* Fri Aug 23 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Sixth candidate for 7.4.0 release
* Mon Aug 19 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Fifth candidate for 7.4.0 release
* Tue Aug 13 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Fourth candidate for 7.4.0 release
* Tue Aug 06 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Third release candidate for 7.4.0
* Fri Aug 02 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Second release candidate for 7.4.0
* Wed Jul 17 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
First candidate for 7.4.0 release
* Tue Jul 16 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
prepare for 7.4.0
* Mon Jul 01 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Third candidate for 7.2.2 release
* Fri Jun 28 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Second candidate for 7.2.2 release
* Wed Jun 26 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Release candidate for 7.2.2 release
* Fri Jun 21 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Second feature freeze for 7.2.2 release
* Mon Jun 17 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Feature freeze for 7.2.2 release
* Mon Jun 03 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
First sprint increment for 7.2.2 release
* Wed May 29 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
First candidate for 7.2.2 release
* Mon May 27 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
prepare for 7.2.2
* Wed May 22 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Third candidate for 7.2.1 release
* Wed May 15 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Second candidate for 7.2.1 release
* Mon Apr 22 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
First candidate for 7.2.1 release
* Mon Apr 15 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
prepare for 7.4.0
* Mon Apr 15 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
prepare for 7.2.1
* Wed Apr 10 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Fourth candidate for 7.2.0 release
* Mon Apr 08 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Third candidate for 7.2.0 release
* Tue Apr 02 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
Second candidate for 7.2.0 release
* Tue Apr 02 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
First candidate for 7.2.0 release
* Fri Mar 15 2013 Martin Hollmichel <martin.hollmichel@open-xchange.com>
prepare for 7.2.0
* Wed Sep 19 2012 Martin Hollmichel <martin.hollmichel@open-xchange.com>
first build
